/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.1 on 2009-11-30 07:36:44,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.doxia.document;

/**
 * Specifies the default behavior for hyperlinks in the document.
 * 
 * @version $Revision$ $Date$
 */
public class DocumentHyperlinkBehaviour
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * 
     *             The name of the default target frame.
     *             <p>
     *               Specifies the name of the default target frame
     * in which to display
     *               a document referenced by a hyperlink.
     *             </p>
     * 
     *             <p>
     *               This attribute can have one of the following
     * values:
     *             </p>
     * 
     *             <dl>
     *               <dd>_self</dd>
     *               <dt>
     *                 The referenced document replaces the content
     *                 of the current frame.
     *               </dt>
     * 
     *               <dd>_blank</dd>
     *               <dt>
     *                 The referenced document is displayed in a
     * new frame.
     *               </dt>
     * 
     *               <dd>_parent</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * parent frame
     *                 of the current frame.
     *               </dt>
     * 
     *               <dd>_top</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * topmost frame,
     *                 that is the frame that contains the current
     * frame as a child
     *                 or descendent but is not contained within
     * another frame.
     *               </dt>
     * 
     *               <dd>A frame name</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * named frame.
     *                 If the named frame does not exist, a new
     * frame with that
     *                 name is created.
     *               </dt>
     *             </dl>
     *           
     */
    private String targetFrame = "_self";


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method equals.
     * 
     * @param other
     * @return boolean
     */
    public boolean equals( Object other )
    {
        if ( this == other )
        {
            return true;
        }

        if ( !( other instanceof DocumentHyperlinkBehaviour ) )
        {
            return false;
        }

        DocumentHyperlinkBehaviour that = (DocumentHyperlinkBehaviour) other;
        boolean result = true;

        result = result && ( getTargetFrame() == null ? that.getTargetFrame() == null : getTargetFrame().equals( that.getTargetFrame() ) );

        return result;
    } //-- boolean equals( Object )

    /**
     * Get the name of the default target frame.
     *             <p>
     *               Specifies the name of the default target frame
     * in which to display
     *               a document referenced by a hyperlink.
     *             </p>
     * 
     *             <p>
     *               This attribute can have one of the following
     * values:
     *             </p>
     * 
     *             <dl>
     *               <dd>_self</dd>
     *               <dt>
     *                 The referenced document replaces the content
     *                 of the current frame.
     *               </dt>
     * 
     *               <dd>_blank</dd>
     *               <dt>
     *                 The referenced document is displayed in a
     * new frame.
     *               </dt>
     * 
     *               <dd>_parent</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * parent frame
     *                 of the current frame.
     *               </dt>
     * 
     *               <dd>_top</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * topmost frame,
     *                 that is the frame that contains the current
     * frame as a child
     *                 or descendent but is not contained within
     * another frame.
     *               </dt>
     * 
     *               <dd>A frame name</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * named frame.
     *                 If the named frame does not exist, a new
     * frame with that
     *                 name is created.
     *               </dt>
     *             </dl>
     * 
     * @return String
     */
    public String getTargetFrame()
    {
        return this.targetFrame;
    } //-- String getTargetFrame()

    /**
     * Method hashCode.
     * 
     * @return int
     */
    public int hashCode()
    {
        int result = 17;

        result = 37 * result + ( targetFrame != null ? targetFrame.hashCode() : 0 );

        return result;
    } //-- int hashCode()

    /**
     * Set the name of the default target frame.
     *             <p>
     *               Specifies the name of the default target frame
     * in which to display
     *               a document referenced by a hyperlink.
     *             </p>
     * 
     *             <p>
     *               This attribute can have one of the following
     * values:
     *             </p>
     * 
     *             <dl>
     *               <dd>_self</dd>
     *               <dt>
     *                 The referenced document replaces the content
     *                 of the current frame.
     *               </dt>
     * 
     *               <dd>_blank</dd>
     *               <dt>
     *                 The referenced document is displayed in a
     * new frame.
     *               </dt>
     * 
     *               <dd>_parent</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * parent frame
     *                 of the current frame.
     *               </dt>
     * 
     *               <dd>_top</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * topmost frame,
     *                 that is the frame that contains the current
     * frame as a child
     *                 or descendent but is not contained within
     * another frame.
     *               </dt>
     * 
     *               <dd>A frame name</dd>
     *               <dt>
     *                 The referenced document is displayed in the
     * named frame.
     *                 If the named frame does not exist, a new
     * frame with that
     *                 name is created.
     *               </dt>
     *             </dl>
     * 
     * @param targetFrame
     */
    public void setTargetFrame( String targetFrame )
    {
        this.targetFrame = targetFrame;
    } //-- void setTargetFrame( String )

    /**
     * Method toString.
     * 
     * @return String
     */
    public java.lang.String toString()
    {
        StringBuffer buf = new StringBuffer( 128 );

        buf.append( "targetFrame = '" );
        buf.append( getTargetFrame() );
        buf.append( "'" );

        return buf.toString();
    } //-- java.lang.String toString()

}
