/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.1 on 2009-11-30 07:36:44,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.doxia.document;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Collection;

/**
 * A menu item.
 * 
 * @version $Revision$ $Date$
 */
public class DocumentTOCItem
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * 
     *             The name to use for the toc.
     *           
     */
    private String name;

    /**
     * 
     *             The ref to use for the item.
     *           
     */
    private String ref;

    /**
     * 
     *            Whether to show any child elements of a TOCItem,
     * overriding
     *            the depth given in DocumentTOC. By default, all
     * children
     *            are expanded up to the depth given in
     * DocumentTOC.
     *           
     */
    private boolean collapse = false;

    /**
     * Field items.
     */
    private java.util.List/*<DocumentTOCItem>*/ items;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addItem.
     * 
     * @param documentTOCItem
     */
    public void addItem( DocumentTOCItem documentTOCItem )
    {
        getItems().add( documentTOCItem );
        documentTOCItem.createDocumentTOCItemAssociation( this );
    } //-- void addItem( DocumentTOCItem )

    /**
     * Method breakDocumentTOCItemAssociation.
     * 
     * @param documentTOCItem
     */
    public void breakDocumentTOCItemAssociation( DocumentTOCItem documentTOCItem )
    {
        if ( ! getItems().contains( documentTOCItem ) )
        {
            throw new IllegalStateException( "documentTOCItem isn't associated." );
        }

        getItems().remove( documentTOCItem );
    } //-- void breakDocumentTOCItemAssociation( DocumentTOCItem )

    /**
     * Method createDocumentTOCItemAssociation.
     * 
     * @param documentTOCItem
     */
    public void createDocumentTOCItemAssociation( DocumentTOCItem documentTOCItem )
    {
        Collection items = getItems();

        if ( items.contains( documentTOCItem ) )
        {
            throw new IllegalStateException( "documentTOCItem is already assigned." );
        }

        items.add( documentTOCItem );
    } //-- void createDocumentTOCItemAssociation( DocumentTOCItem )

    /**
     * Method equals.
     * 
     * @param other
     * @return boolean
     */
    public boolean equals( Object other )
    {
        if ( this == other )
        {
            return true;
        }

        if ( !( other instanceof DocumentTOCItem ) )
        {
            return false;
        }

        DocumentTOCItem that = (DocumentTOCItem) other;
        boolean result = true;

        result = result && ( getName() == null ? that.getName() == null : getName().equals( that.getName() ) );
        result = result && ( getRef() == null ? that.getRef() == null : getRef().equals( that.getRef() ) );
        result = result && collapse == that.collapse;
        result = result && ( getItems() == null ? that.getItems() == null : getItems().equals( that.getItems() ) );

        return result;
    } //-- boolean equals( Object )

    /**
     * Method getItems.
     * 
     * @return List
     */
    public java.util.List/*<DocumentTOCItem>*/ getItems()
    {
        if ( this.items == null )
        {
            this.items = new java.util.ArrayList/*<DocumentTOCItem>*/();
        }

        return this.items;
    } //-- java.util.List/*<DocumentTOCItem>*/ getItems()

    /**
     * Get the name to use for the toc.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName()

    /**
     * Get the ref to use for the item.
     * 
     * @return String
     */
    public String getRef()
    {
        return this.ref;
    } //-- String getRef()

    /**
     * Method hashCode.
     * 
     * @return int
     */
    public int hashCode()
    {
        int result = 17;

        result = 37 * result + ( name != null ? name.hashCode() : 0 );
        result = 37 * result + ( ref != null ? ref.hashCode() : 0 );
        result = 37 * result + ( collapse ? 0 : 1 );
        result = 37 * result + ( items != null ? items.hashCode() : 0 );

        return result;
    } //-- int hashCode()

    /**
     * Get whether to show any child elements of a TOCItem,
     * overriding
     *            the depth given in DocumentTOC. By default, all
     * children
     *            are expanded up to the depth given in
     * DocumentTOC.
     * 
     * @return boolean
     */
    public boolean isCollapse()
    {
        return this.collapse;
    } //-- boolean isCollapse()

    /**
     * Method removeItem.
     * 
     * @param documentTOCItem
     */
    public void removeItem( DocumentTOCItem documentTOCItem )
    {
        documentTOCItem.breakDocumentTOCItemAssociation( this );
        getItems().remove( documentTOCItem );
    } //-- void removeItem( DocumentTOCItem )

    /**
     * Set whether to show any child elements of a TOCItem,
     * overriding
     *            the depth given in DocumentTOC. By default, all
     * children
     *            are expanded up to the depth given in
     * DocumentTOC.
     * 
     * @param collapse
     */
    public void setCollapse( boolean collapse )
    {
        this.collapse = collapse;
    } //-- void setCollapse( boolean )

    /**
     * Set a table of content item containing sub-items.
     * 
     * @param items
     */
    public void setItems( java.util.List/*<DocumentTOCItem>*/ items )
    {
        this.items = items;
    } //-- void setItems( java.util.List )

    /**
     * Set the name to use for the toc.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String )

    /**
     * Set the ref to use for the item.
     * 
     * @param ref
     */
    public void setRef( String ref )
    {
        this.ref = ref;
    } //-- void setRef( String )

    /**
     * Method toString.
     * 
     * @return String
     */
    public java.lang.String toString()
    {
        StringBuffer buf = new StringBuffer( 128 );

        buf.append( "name = '" );
        buf.append( getName() );
        buf.append( "'" );
        buf.append( "\n" ); 
        buf.append( "ref = '" );
        buf.append( getRef() );
        buf.append( "'" );
        buf.append( "\n" ); 
        buf.append( "collapse = '" );
        buf.append( isCollapse() );
        buf.append( "'" );
        buf.append( "\n" ); 
        buf.append( "items = '" );
        buf.append( getItems() );
        buf.append( "'" );

        return buf.toString();
    } //-- java.lang.String toString()

}
